function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState, useEffect } from 'react';
import { SingleItemContainer } from './SingleItemContainer';
import { mount } from '../utils/env';
import { warning } from '../utils/warning';
var singletonContainerMounted = false;
var singletonContainerRendered = false;
var singletonContainerMountedAutomatically = false;
var mountQueue = [];

var mountIntoContainerDefault = function mountIntoContainerDefault(item) {
  mountQueue.push(item);
};

var mountIntoContainer = mountIntoContainerDefault;
export var SingletonContainer = function SingletonContainer() {
  singletonContainerRendered = true;
  useEffect(function () {
    if (singletonContainerMounted) {
      warning('SingletonContainer is mounted second time. ' + 'You should mount SingletonContainer before any other component and never unmount it.' + 'Alternatively, dont use SingletonContainer it at all, we will handle that for you.');
    }

    singletonContainerMounted = true;
    return function () {
      return process.env.NODE_ENV !== 'test' && warning('SingletonContainer is removed from DOM. its not supported, singleton hooks will stop updating.');
    };
  }, []);

  var _useState = useState([]),
      hooks = _useState[0],
      setHooks = _useState[1];

  useEffect(function () {
    mountIntoContainer = function mountIntoContainer(item) {
      return setHooks(function (hooks) {
        return [].concat(hooks, [item]);
      });
    };

    setHooks(mountQueue);
  }, []);
  return React.createElement(React.Fragment, null, hooks.map(function (h, i) {
    return React.createElement(SingleItemContainer, _extends({}, h, {
      key: i
    }));
  }));
};
export var addHook = function addHook(hook) {
  if (!singletonContainerRendered && !singletonContainerMountedAutomatically) {
    singletonContainerMountedAutomatically = true;
    mount(SingletonContainer);
  }

  mountIntoContainer(hook);
};
export var resetLocalStateForTests = function resetLocalStateForTests() {
  singletonContainerMounted = false;
  singletonContainerRendered = false;
  singletonContainerMountedAutomatically = false;
  mountQueue = [];
  mountIntoContainer = mountIntoContainerDefault;
};